package com.example.posts.di

import android.content.Context
import com.example.posts.PostsApp
import dagger.BindsInstance
import dagger.Component
import dagger.android.AndroidInjectionModule
import dagger.android.AndroidInjector
import javax.inject.Singleton

@Singleton
@Component(modules = [
    AndroidInjectionModule::class,
    ScreensModule::class,
    UtilsModule::class,
    FrameworkDependencies::class
])
interface ApplicationComponent : AndroidInjector<PostsApp> {

    @Component.Factory
    interface Factory {
        fun create(@BindsInstance applicationContext: Context): ApplicationComponent
    }
}